// dom.js Domo v1.0 2020-07-03
// Author: Alberto González Palomo http://sentido-labs.com
// ©2016-2018 Alberto González Palomo http://sentido-labs.com
// License: MIT, https://opensource.org/licenses/MIT
var dom=function(t){"use strict";function e(n,r,i,u){r||(r={}),i||(i=t);var a;if(Array.isArray(n)){var c=0;if(a=n[c++],"string"==typeof a&&a.replace(/(?:(\w*):)?([^. #]*)((?:[. ][^. #]*)*)(?:#(.*))?/,function(t,e,n,u,c){var f=r[e||""];a=n?f?i.createElementNS(
f,n):e?o("Undefined prefix "+e):i.createElement(n):i.createDocumentFragment(),u=u.replace(/\./g," ").trim(),u&&a.setAttribute("class",u),c&&a.setAttribute("id",c)}),!(a instanceof Node))return o("Node head is "+a+" in "+JSON.stringify(n)),e("ERROR");var f=n.
length;if(c<f){var l=n[c];l&&l.constructor&&"Object"===l.constructor.name&&(Object.keys(l).forEach(function(t){var e=l[t];"function"==typeof e?a.addEventListener(t.replace(/^on/,""),e):null!==e&&!1!==e&&a.setAttribute(t,e)}),++c)}if(u)for(;c<f;)a.appendChild(
e(u(n[c++]),r,i,u));else for(;c<f;)a.appendChild(e(n[c++],r,i))}else a=n instanceof Node?n:i.createTextNode(n);return a}function n(){var t=this.result;return this.i<t.length?t.item(this.i++):null}function r(){var t=this.array;return this.i<t.length?t[this.i++
]:null}function i(t,e){function n(t){return e[t]}function r(e){try{var r=t.createExpression(e,n);return r.node=i,r.iter=u,r.array=a,r.bool=c,r.num=f,r.str=l,r}catch(t){o(t.message+"\n"+e,t.fileName,t.lineNumber)}}function i(t){return this.evaluate(t,9,null).
singleNodeValue}function u(t){return this.evaluate(t,4,null)}function a(t){for(var e,n=[],r=this.iter(t);e=r.iterateNext();)n.push(e);return n}function c(t){return this.evaluate(t,3,null).booleanValue}function f(t){return this.evaluate(t,1,null).numberValue}
function l(t){return this.evaluate(t,2,null).stringValue}return e||(e={}),r}function u(t){function e(e,i,o,a){var c=i+"."+(o||"")+"."+e.new.name;return(u[c]||(u[c]=function(u){return o&&u.addEventListener(o,function(r){t[i]=e.get(r.target),n(i,u)}),r(i,
function(t,n,r){r!==u&&e.set(u,t[n])}),u}))(a)}function n(e,n){var r=[];"string"==typeof e&&(e=[e]),e.forEach(function(t){"*"===t?Object.keys(o).forEach(function(t){"*"!==t&&r.concat(o[t])}):o.hasOwnProperty(t)&&(r=r.concat(o[t]))}),o.hasOwnProperty("*")&&(r=
r.concat(o["*"]));for(var i=0;i<r.length;++i){var u=r[i];if(r.indexOf(u)===i&&u.f!==n){if(-1!==a.indexOf(u))return console.error("Domo listener loop",a.concat([u]).map(function(t){return t.f.name}));a.push(u),u.f(t,e[0],n),a.pop()}}}function r(e,n){var r={f:n
,c:[]};return(o[e]||(o[e]=[])).push(r),a.forEach(function(t){t.c.push(r)}),a.push(r),n(t,e,!1),a.pop(),r}function i(t){var e=t.c.slice();e.push(t),Object.keys(o).map(function(t){return o[t]}).forEach(function(t){for(var n=t.length;n;)-1!==e.indexOf(t[--n])&&t
.splice(n,1)})}this.model=t,this.bind=e,this.changed=n,this.addListener=r,this.removeListener=i;var u={},o={},a=[]}function o(t,e,n){throw new Error(t,e,n)}e.clear=function(t){return t.textContent="",t},e.id=function(e,n){return(n||t).getElementById(e)},e.$=
function(e,n){return(n||t).querySelector(e)},e.$$=function(e,n){return Array.prototype.slice.call((n||t).querySelectorAll(e))},e.iter=function(e,r){return{i:0,result:(r||t).querySelectorAll(e),iterateNext:n}},e.iterFromArray=function(t){return{i:0,array:t,
iterateNext:r}};var a=1e3;return e.iterateAsync=function(t,e,n,r){function i(u){for(var o,c=u,f=Date.now();c--&&null!==(o=t.iterateNext());)e(o);n&&!1===n(u)||(null===o?r&&r(u):(f=Math.max(1e4,Math.min(1e-4,a
/(Date.now()-f))),setTimeout(i,10,0|u*f)))}i(16)},e.batch=function(t,e,n){function r(i,u){var o=u+i,c=o>=t.length,f=Date.now();e(t,u,Math.min(t.length,o)),c?(console.log("Final batch size:",i),n&&n()):(f=Math.max(1e4,Math.min(1e-4,a/(Date.now()-f))),
setTimeout(r,10,0|i*f,o))}r(16,0)},e.XPath={new:i},e.Nexus={new:function(t){return new u(t)}},e}(document);